// Подключаем библиотеки для работы с Motor Shield и Software Serial

#include <AFMotor.h>
#include <SoftwareSerial.h>

//Определяем пины для эмуляции

SoftwareSerial mySerial(A0, A1); // RX, TX

// Определяем левый мотор на клемник номер 2

AF_DCMotor l_motor(2);

// Определяем правый мотор на клемник номер 3

AF_DCMotor r_motor(3);

//Переменные для определения скорости
// и корректировки вращения

float spd = 70.0;
float corr_l = 0.62;
float corr_r = 1;
float rot = 50.0;

void setup()
{
  //Задаем начальную скорость и выключаем моторы

  l_motor.setSpeed(spd);
  l_motor.run(RELEASE);

  r_motor.setSpeed(spd);
  r_motor. run(RELEASE);

  //Устанавливаем соединение с HC-06

  mySerial.begin(9600);
}

void loop()
{
  //Если появились данные,
  //вызываем функцию управления

  if (mySerial.available())
  {
    drive();
  }
}



void drive()
{
  //Переменная для пришедших данных

  char control = mySerial.read();

  //Для начала установим скорость

  if (((control - '0') >= 0) && ((control - '0') <= 9))
  {
    spd = (control - '0') * 25.0; //сохраняем новое значение скорости
  }
  else if (control == 'q')
  {
    spd = 255.0;
  }

  //Сравниваем команды, пришедшие со смартфона

  else if (control == 'S') //Если пришла команда "S", стоим
  {
    l_motor.run(RELEASE);
    r_motor. run(RELEASE);
  }

  else if (control == 'F') //Если пришла команда "F", едем вперед
  {
    l_motor.setSpeed(spd * corr_l);
    r_motor.setSpeed(spd * corr_r);
    r_motor.run(FORWARD);
    l_motor.run(FORWARD);
  }

  else if (control == 'B') //Если пришла команда "B", едем назад
  {
    l_motor.setSpeed(spd * corr_l);
    r_motor.setSpeed(spd * corr_r);
    r_motor.run(BACKWARD);
    l_motor.run(BACKWARD);
  }

   else if (control == 'I') //Если пришла команда "I", едем вперёд и направо
    {
    l_motor.setSpeed(spd * corr_l);
    r_motor.setSpeed(spd * corr_r + rot);
    r_motor.run(FORWARD);
    l_motor.run(FORWARD);
    }
  else if (control == 'J')//Если пришла команда "J", едем назад и направо
    {
    l_motor.setSpeed(spd * corr_l);
    r_motor.setSpeed(spd * corr_r + rot);
    r_motor.run(BACKWARD);
    l_motor.run(BACKWARD);
    }

  else if (control == 'G')   //Если пришла команда "G", едем вперёд и налево
   {
    l_motor.setSpeed(spd * corr_l + rot);
    r_motor.setSpeed(spd * corr_r);
    r_motor.run(FORWARD);
    l_motor.run(FORWARD);
   }

  else if (control == 'H')   //Если пришла команда "H", едем назад и налево
   {
    l_motor.setSpeed(spd * corr_l + rot);
    r_motor.setSpeed(spd * corr_r);
    r_motor.run(BACKWARD);
    l_motor.run(BACKWARD);
   }
   
   else if (control == 'R') //Если пришла команда "R", крутимся вправо
  {
    l_motor.setSpeed(spd * corr_l);
    r_motor.setSpeed(spd * corr_r);
    r_motor.run(FORWARD);
    l_motor.run(BACKWARD);
  }

  else if (control = 'L') //Если пришла командв "L", крутимся влево
  {
    l_motor.setSpeed(spd * corr_l);
    r_motor.setSpeed(spd * corr_r);
    l_motor.run(FORWARD);
    r_motor.run(BACKWARD);
  }

     
}

